]> code.delx.au - gnu-emacs/blob - make-dist
The shell comment char is #, not ;.
[gnu-emacs] / make-dist
1 #!/bin/sh
2
3 #### make-dist: create an Emacs distribution tar file from the current
4 #### source tree. This basically creates a duplicate directory
5 #### structure, and then hard links into it only those files that should
6 #### be distributed. This means that if you add a file with an odd name,
7 #### you should make sure that this script will include it.
8
9 progname="$0"
10
11 ### Exit if a command fails.
12 ### set -e
13
14 ### Print out each line we read, for debugging's sake.
15 ### set -v
16
17 clean_up=yes
18 make_tar=yes
19 newer=""
20
21 while [ $# -gt 0 ]; do
22 case "$1" in
23 ## This option tells make-dist not to delete the staging directory
24 ## after it's done making the tar file.
25 "--no-clean-up" )
26 clean_up=no
27 ;;
28 ## This option tells make-dist not to make a tar file. Since it's
29 ## rather pointless to build the whole staging directory and then
30 ## nuke it, using this option also selects '--no-clean-up'.
31 "--no-tar" )
32 make_tar=no
33 clean_up=no
34 ;;
35 ## This option tells make-dist to make the distribution normally, then
36 ## remove all files newer than the given timestamp file. This is useful
37 ## for creating incremental or patch distributions
38 "--newer")
39 newer="$2"
40 new_extension=".new"
41 shift
42 ;;
43 * )
44 echo "${progname}: Unrecognized argument: $1" >&2
45 exit 1
46 ;;
47 esac
48 shift
49 done
50
51 ### Make sure we're running in the right place.
52 if [ ! -d src -o ! -f src/lisp.h -o ! -d lisp -o ! -f lisp/version.el ]; then
53 echo "${progname}: Can't find \`src/lisp.h' and \`lisp/version.el'." >&2
54 echo "${progname} must be run in the top directory of the Emacs" >&2
55 echo "distribution tree. Cd to that directory and try again." >&2
56 exit 1
57 fi
58
59 ### Find out which version of Emacs this is.
60 version=`grep 'defconst[ ]*emacs-version' lisp/version.el \
61 | sed -e 's/^.*"\([0-9][0-9]*\.[0-9][0-9]*\)\..*$/\1/'`
62 if [ ! "${version}" ]; then
63 echo "${progname}: can't find current emacs version in \`./lisp/version.el'." >&2
64 exit 1
65 fi
66
67 ### Make sure the subdirectory is available.
68 tempparent="make-dist.tmp.$$"
69 if [ -d ${tempparent} ]; then
70 echo "${progname}: staging directory \`${tempparent}' already exists.
71 Perhaps a previous invocation of \`${progname}' failed to clean up after
72 itself. Check that directories whose names are of the form
73 \`make-dist.tmp.NNNNN' don't contain any important information, remove
74 them, and try again." >&2
75 exit 1
76 fi
77
78 echo "Creating staging directory: \`${tempparent}'"
79 mkdir ${tempparent}
80 emacsname="emacs-${version}${new_extension}"
81 tempdir="${tempparent}/${emacsname}"
82
83 ### This trap ensures that the staging directory will be cleaned up even
84 ### when the script is interrupted in mid-career.
85 if [ "${clean_up}" = yes ]; then
86 trap "echo 'Interrupted...cleaning up the staging directory.'; rm -rf ${tempparent}; exit 1" 1 2 15
87 fi
88
89 echo "Creating top directory: \`${tempdir}'"
90 mkdir ${tempdir}
91
92 ### We copy in the top-level files before creating the subdirectories in
93 ### hopes that this will make the top-level files appear first in the
94 ### tar file; this means that people can start reading the INSTALL and
95 ### README while the rest of the tar file is still unpacking. Whoopee.
96 echo "Making links to top-level files."
97 ln GETTING.GNU.SOFTWARE INSTALL PROBLEMS README move-if-change ${tempdir}
98 ln ChangeLog Makefile.in build-install.in configure ${tempdir}
99 ln make-dist ${tempdir}
100 ### Copy config.sub; it's a cross-filesystem symlink.
101 cp config.sub ${tempdir}
102
103 echo "Creating subdirectories."
104 for subdir in lisp lisp/calc-2.02 lisp/term local-lisp external-lisp \
105 src src/m src/s lib-src oldXMenu \
106 etc lock cpp info man shortnames vms; do
107 mkdir ${tempdir}/${subdir}
108 done
109
110 echo "Making links to \`lisp'."
111 ### Don't distribute =*.el files, site-init.el, site-load.el, or default.el.
112 (cd lisp
113 ln [a-zA-Z]*.el ../${tempdir}/lisp
114 ln [a-zA-Z]*.elc ../${tempdir}/lisp
115 ## simula.el doesn't keep abbreviations in simula.defns any more.
116 ## ln [a-zA-Z]*.defns ../${tempdir}/lisp
117 ln ChangeLog README ../${tempdir}/lisp
118 cd ../${tempdir}/lisp
119 rm -f site-init site-init.el site-init.elc
120 rm -f site-load site-load.el site-load.elc
121 rm -f default default.el default.elc)
122
123 echo "Making links to \`lisp/calc-2.02'."
124 ### Don't distribute =*.el files or backups.
125 (cd lisp/calc-2.02
126 ln [a-zA-Z]*.el ../../${tempdir}/lisp/calc-2.02
127 ln [a-zA-Z]*.elc ../../${tempdir}/lisp/calc-2.02
128 ln calc.info* calc.texinfo calc-refcard.* ../../${tempdir}/lisp/calc-2.02
129 ln INSTALL Makefile README README.prev ../../${tempdir}/lisp/calc-2.02
130 cd ../../${tempdir}/lisp/calc-2.02
131 rm -f *~)
132
133 echo "Making links to \`lisp/term'."
134 ### Don't distribute =*.el files.
135 (cd lisp/term
136 ln [a-zA-Z]*.el ../../${tempdir}/lisp/term
137 ln [a-zA-Z]*.elc ../../${tempdir}/lisp/term
138 ln README ../../${tempdir}/lisp/term)
139
140 echo "Making links to \`external-lisp'."
141 ### Don't distribute =*.el files.
142 (cd external-lisp
143 ln [a-zA-Z]*.el ../${tempdir}/external-lisp
144 ln [a-zA-Z]*.elc ../${tempdir}/external-lisp
145 ln ChangeLog README ../${tempdir}/external-lisp)
146
147 echo "Making links to \`src'."
148 ### Don't distribute =*.[ch] files, or the configured versions of
149 ### config.h.in, paths.h.in, or Makefile.in.
150 (cd src
151 echo " (If we can't link gmalloc.c, that's okay.)"
152 ln [a-zA-Z]*.c ../${tempdir}/src
153 ## Might be a symlink to a file on another filesystem.
154 cp gmalloc.c ../${tempdir}/src
155 ln [a-zA-Z]*.h ../${tempdir}/src
156 ln [a-zA-Z]*.s ../${tempdir}/src
157 ln README Makefile.in ymakefile ChangeLog config.h.in paths.h.in \
158 ../${tempdir}/src
159 ln .gdbinit .dbxinit ../${tempdir}/src
160 ln *.opt vms-pp.trans ../${tempdir}/src
161 cd ../${tempdir}/src
162 rm -f config.h paths.h Makefile
163 if [ -z "${newer}" ]; then
164 etags *.h *.c ../lisp/*.el
165 fi)
166
167 echo "Making links to \`src/m'."
168 (cd src/m
169 ln README [a-zA-Z0-9]*.h ../../${tempdir}/src/m)
170
171 echo "Making links to \`src/s'."
172 (cd src/s
173 ln README [a-zA-Z0-9]*.h ../../${tempdir}/src/s)
174
175 echo "Making links to \`lib-src'."
176 (cd lib-src
177 ln [a-zA-Z]*.[chy] [a-zA-Z]*.lex [a-zA-Z]*.com ../${tempdir}/lib-src
178 ln ChangeLog Makefile.in README testfile vcdiff rcs2log ../${tempdir}/lib-src
179 ln emacs.csh ../${tempdir}/lib-src
180 cd ../${tempdir}/lib-src
181 rm -f getdate.c getdate.tab.c y.tab.c y.tab.h)
182
183 echo "Making links to \`oldXMenu'."
184 (cd oldXMenu
185 ln *.c *.h ../${tempdir}/oldXMenu
186 ln README Makefile Imakefile ChangeLog ../${tempdir}/oldXMenu)
187
188 echo "Making links to \`etc'."
189 ### Don't distribute DOC files, backups, autosaves, or tex litter.
190 (cd etc
191 ln [0-9a-zA-Z]* ../${tempdir}/etc
192 cd ../${tempdir}/etc
193 ## Avoid an error when expanding the wildcards later.
194 for dummy in DOC-dummy dummy~ \#dummy\# dummy.dvi dummy.log; do
195 ln MACHINES ${dummy}
196 done
197 rm -f DOC* *~ \#*\# *.dvi *.log core)
198
199 echo "Making links to \`cpp'."
200 (cd cpp
201 ln cccp.c cexp.y Makefile README ../${tempdir}/cpp)
202
203 ###!! echo "Making links to \`info'."
204 ###!! # Don't distribute backups or autosaves.
205 ###!! (cd info
206 ###!! ln [a-zA-Z]* ../${tempdir}/info
207 ###!! cd ../${tempdir}/info
208 ###!! # Avoid an error when expanding the wildcards later.
209 ###!! ln emacs dummy~ ; ln emacs \#dummy\#
210 ###!! rm -f *~ \#*\# core)
211
212 echo "Making links to \`man'."
213 (cd man
214 ln *.tex *.texinfo *.texi *.aux *.cps *.fns *.kys *.vrs ../${tempdir}/man
215 ln *.c ../${tempdir}/man
216 ln ChangeLog Makefile README split-man ../${tempdir}/man)
217
218 echo "Making links to \`shortnames'."
219 (cd shortnames
220 ln *.c ../${tempdir}/shortnames
221 ln Makefile reserved special ../${tempdir}/shortnames)
222
223 echo "Making links to \`vms'."
224 (cd vms
225 ln [0-9a-zA-Z]* ../${tempdir}/vms
226 cd ../${tempdir}/vms
227 rm -f *~)
228
229 ### It would be nice if they could all be symlinks to etc's copy, but
230 ### you're not supposed to have any symlinks in distribution tar files.
231 echo "Making sure copying notices are all copies of \`etc/COPYING'."
232 rm -f ${tempdir}/etc/COPYING
233 cp etc/COPYING ${tempdir}/etc/COPYING
234 for subdir in lisp external-lisp src lib-src info shortnames; do
235 if [ -f ${tempdir}/${subdir}/COPYING ]; then
236 rm ${tempdir}/${subdir}/COPYING
237 fi
238 cp etc/COPYING ${tempdir}/${subdir}
239 done
240
241 if [ "${newer}" ]; then
242 echo "Removing files older than $newer."
243 ## We remove .elc files unconditionally, on the theory that anyone picking
244 ## up an incremental distribution already has a running Emacs to byte-compile
245 ## them with.
246 find ${tempparent} \( -name '*.elc' -o ! -newer ${newer} \) -exec rm -f {} \;
247 fi
248
249 if [ "${make_tar}" = yes ]; then
250 echo "Creating tar file."
251 (cd ${tempparent}; tar cvf - ${emacsname}) | compress > ${emacsname}.tar.Z
252 fi
253
254 if [ "${clean_up}" = yes ]; then
255 echo "Cleaning up the staging directory."
256 rm -rf ${tempparent}
257 fi
258
259 ### make-dist ends here